
// DeviceSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DeviceSample.h"
#include "DeviceSampleDlg.h"

#include "itc50.h"
#include "itc50msgsys.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CListBox *pMyListBox;				//listbox handle
//CComboBox *pComboBoxCtrl;			//combbox for LED Type 
//CEdit *pEditActivePeriodCtrl;		//edit for Active Period
//CEdit *pEditBlinkRateCtrl;			//edit for Blink Rate

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// DeviceSampleDlg dialog




DeviceSampleDlg::DeviceSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(DeviceSampleDlg::IDD, pParent)
	
	
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void DeviceSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//DDX_CBString(pDX, IDC_COMBO_LED_TYPE, m_combBoxLEDType);
	//DDX_Text(pDX, IDC_EDIT_ACTIVE_PERIOD, m_editActivePeriod);
	//DDX_Text(pDX, IDC_EDIT2, m_editBlinkRate);
}

BEGIN_MESSAGE_MAP(DeviceSampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_GET_LED, &DeviceSampleDlg::OnBnClickedButtonGetSerialNumber)
	ON_BN_CLICKED(IDC_BUTTON_SET_LED, &DeviceSampleDlg::OnBnClickedButtonGetModel)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_OUTPUT, &DeviceSampleDlg::OnBnClickedButtonClearOutput)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, &DeviceSampleDlg::OnBnClickedButtonExit)
	ON_BN_CLICKED(IDC_SUSPENDBUTTON, &DeviceSampleDlg::OnBnClickedSuspendbutton)
	ON_BN_CLICKED(IDC_BUTTONWARMBOOT, &DeviceSampleDlg::OnBnClickedButtonwarmboot)
	ON_BN_CLICKED(IDC_BUTTONGETPOWERSTATUS, &DeviceSampleDlg::OnBnClickedButtongetpowerstatus)
	//ON_BN_DOUBLECLICKED(IDC_BUTTONGETSCREENBRIGHTNESS, &DeviceSampleDlg::OnBnDoubleclickedButtongetscreenbrightness)
		
	ON_BN_CLICKED(IDC_BUTTONPLAYAUDIOTONE, &DeviceSampleDlg::OnBnClickedButtonplayaudiotone)
END_MESSAGE_MAP()


// DeviceSampleDlg message handlers

BOOL DeviceSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	//set the listbox control handle
	pMyListBox = (CListBox *)GetDlgItem(IDC_LIST_DATA);	

	//set the Led No edit
//	pComboBoxCtrl = (CComboBox *)GetDlgItem(IDC_COMBO_LED_TYPE);	

	//set the Active Period edit
//	pEditActivePeriodCtrl = (CEdit *)GetDlgItemInt(IDC_EDIT_ACTIVE_PERIOD);

	//set the Blink Rate edit
	//pEditBlinkRateCtrl = (CEdit *)GetDlgItemInt(IDC_EDIT_BLINK_RATE);

//	pComboBoxCtrl->SetFocus();

	HCURSOR prevCursor = SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

	//cause the changed data to be displayed
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void DeviceSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void DeviceSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR DeviceSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void DeviceSampleDlg::OnBnClickedButtonGetSerialNumber()
{
	//get m_editLedNo variable value from IDC_EDIT_LED_NO EditBox
	UpdateData(TRUE);	

	HRESULT retValue = ITC_ERROR;
	TCHAR tszSerialNumber[50] = {0};
	retValue = ITCGetSerialNumber(tszSerialNumber,50);

	if(retValue == S_OK)
	{
		TCHAR dataBuf[100] = {0};			
		wsprintf(dataBuf, _T("Serial Number = %s"), tszSerialNumber);
		pMyListBox->AddString(dataBuf);	
	}
	else
	{
		pMyListBox->AddString(L"Failed to get ITCGetSerialNumber");
	}		
}

void DeviceSampleDlg::OnBnClickedButtonGetModel()
{
	//update veriables value
	UpdateData(TRUE);

	HRESULT retValue = ITC_ERROR;
	
	int iDeviceType = ITCGetDeviceType();
	
	if(iDeviceType == ITC_DEVICE_UNKN)
	{	
		TCHAR dataBuf[100] = {0};			
		wsprintf(dataBuf, _T("Device Type = Not Supported"));
		pMyListBox->AddString(dataBuf);
	}
	
}

void DeviceSampleDlg::OnBnClickedButtonClearOutput()
{
	//remove items from listbox
	pMyListBox->ResetContent();
}

void DeviceSampleDlg::OnBnClickedButtonExit()
{
	CDialog::OnCancel();
}

void DeviceSampleDlg::OnBnClickedSuspendbutton()
{
	// TODO: Add your control notification handler code here
	HRESULT retValue = ITC_ERROR;
	retValue = ITCSuspend();
	if(retValue == ITC_FAIL)
	{
		pMyListBox->AddString(L"ITCSuspend Fail");
	}	
	else if(retValue == ITC_ERROR_FUNCTION_NOT_SUPPORTED)
	{
		TCHAR dataBuf[100] = {0};			
		wsprintf(dataBuf, _T("ITCSuspend Not Supported"));
		pMyListBox->AddString(dataBuf);
	}
}

void DeviceSampleDlg::OnBnClickedButtonwarmboot()
{
	// TODO: Add your control notification handler code here
	HRESULT retValue = ITC_ERROR;
	retValue = ITCWarmBoot();
	if(retValue == ITC_FAIL)
	{
		pMyListBox->AddString(L"ITCWarmBoot Fail");
	}	
	else if(retValue == ITC_ERROR_FUNCTION_NOT_SUPPORTED)
	{
		TCHAR dataBuf[100] = {0};			
		wsprintf(dataBuf, _T("ITCWarmBoot Not Supported"));
		pMyListBox->AddString(dataBuf);
	}
}

void DeviceSampleDlg::OnBnClickedButtongetpowerstatus()
{
	// TODO: Add your control notification handler code here
	HRESULT retValue = ITC_ERROR;
	DWORD dwLineStatus;
	DWORD dwBatteryStatus;
	DWORD dwBackupStatus;
	UINT  uintFuelGauge;
	retValue = ITCPowerStatus(&dwLineStatus,&dwBatteryStatus,&dwBackupStatus,&uintFuelGauge);
	if(retValue == ITC_SUCCESS)
	{
		if(dwLineStatus == ITC_ACLINE_NOT_CONNECTED)
			pMyListBox->AddString(L"AC line is not connected.");
		else if(dwLineStatus == ITC_ACLINE_CONNECTED)
			pMyListBox->AddString(L"AC line is connected.");
		else if(dwLineStatus == ITC_UNKNOWN_ACLINE)
			pMyListBox->AddString(L"AC line status is unknown.");
		
		
		if(dwBatteryStatus == ITC_HIGH_BAT)
			pMyListBox->AddString(L"Battery charge is high.");
		else if(dwBatteryStatus == ITC_LOW_BAT)
			pMyListBox->AddString(L"Battery charge is low.");
		else if(dwBatteryStatus == ITC_CRITICAL_BAT)
			pMyListBox->AddString(L"Battery charge is critical.");
		else if(dwBatteryStatus == ITC_CHARGING_BAT)
			pMyListBox->AddString(L"Battery is charging now.");
		else if(dwBatteryStatus == ITC_NO_SYSTEM_BAT)
			pMyListBox->AddString(L"No system battery.");
		else if(dwBatteryStatus == ITC_UNKNOWN_BAT)
			pMyListBox->AddString(L"Battery condition is unknown.");

		if(dwBackupStatus == ITC_HIGH_BACKUP)
			pMyListBox->AddString(L"Backup battery is high.");
		else if(dwBackupStatus == ITC_LOW_BACKUP)
			pMyListBox->AddString(L"Backup battery is low.");
		else if(dwBackupStatus == ITC_CRITICAL_BACKUP)
			pMyListBox->AddString(L"Backup battery is critical.");
		else if(dwBackupStatus == ITC_CHARGING_BACKUP)
			pMyListBox->AddString(L"Backup battery is charging now.");
		else if(dwBackupStatus == ITC_NO_SYSTEM_BACKUP)
			pMyListBox->AddString(L"No system backup battery.");
		else if(dwBackupStatus == ITC_UNKNOWN_BACKUP)
			pMyListBox->AddString(L"Backup battery condition is unknown.");
		
		if(uintFuelGauge == 255)
			pMyListBox->AddString(L"Battery life is unknown.");
		else
		{
			TCHAR dataBuf[100] = {0};			
			wsprintf(dataBuf, _T("%d:Percentage of battery charge"), uintFuelGauge);
			pMyListBox->AddString(dataBuf);
		}
	}
	if(retValue == ITC_FAIL)
	{
		pMyListBox->AddString(L"ITCPowerStatus Fail");
	}	
	else if(retValue == ITC_ERROR_FUNCTION_NOT_SUPPORTED)
	{
		TCHAR dataBuf[100] = {0};			
		wsprintf(dataBuf, _T("ITCPowerStatus Not Supported"));
		pMyListBox->AddString(dataBuf);
	}
}

void DeviceSampleDlg::OnBnClickedButtonplayaudiotone()
{
	// TODO: Add your control notification handler code here
	HRESULT hr;
    // Abort if this functionality is not supported on the device.
    // 
    if( ! ITCIsAudioToneSupported() )
    return;
    // Play a tone at several octaves.
    //
    hr = ITCAudioPlayTone( 300,  200, ITC_GetToneVolumeVeryLoud() );
    hr = ITCAudioPlayTone( 600,  200, ITC_GetToneVolumeLoud() );
    hr = ITCAudioPlayTone( 1200, 200, ITC_GetToneVolumeNormal() );
    hr = ITCAudioPlayTone( 2400, 200, ITC_GetToneVolumeLow() );
    // Insert a silent pause for 1 second.
    //
    hr = ITCAudioPlayTone( 0, 1000, 0 );
    // Play a tone at the device's current volume setting.
    //
    hr = ITCAudioPlayTone( 1200, 200, ITC_TONE_VOLUME_CURRENT );
    // Generate a loud click sound.
    //
    hr = ITCAudioPlayTone( 
    ITC_GetTonePitchClick(), 
    ITC_GetToneDurationClick(), 
    ITC_GetToneVolumeVeryLoud() );
}
